/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MATRIXEDIT_H
#define MATRIXEDIT_H

#include "qad_widgets_export.h"

#include <QWidget>


namespace Ui {
class MatrixEdit;
}


class QAD_WIDGETS_EXPORT MatrixEdit: public QWidget {
	Q_OBJECT

public:
	explicit MatrixEdit(QWidget * parent = nullptr);
	~MatrixEdit() override;

	bool isReadOnly() const;
	void setReadOnly(bool yes);

	QVector<double> vector() const;
	QVector<QVector<double>> matrix() const;
	void setVector(const QVector<double> & v);
	void setMatrix(const QVector<QVector<double>> & v);

private slots:
	void on_spinRows_valueChanged(int cnt);
	void on_spinCols_valueChanged(int cnt);
	void on_buttonNull_clicked();
	void on_buttonIdentity_clicked();

signals:
	void changed();

private:
	void setVectorMode(bool yes);
	void clear(bool ident = false);
	void changeEvent(QEvent * e) override;

	Ui::MatrixEdit * ui;
	bool ro;
};


#endif // MATRIXEDIT_H
